part of 'generated.dart';

class GetApplicationsByShiftIdVariablesBuilder {
  String shiftId;

  final FirebaseDataConnect _dataConnect;
  GetApplicationsByShiftIdVariablesBuilder(this._dataConnect, {required  this.shiftId,});
  Deserializer<GetApplicationsByShiftIdData> dataDeserializer = (dynamic json)  => GetApplicationsByShiftIdData.fromJson(jsonDecode(json));
  Serializer<GetApplicationsByShiftIdVariables> varsSerializer = (GetApplicationsByShiftIdVariables vars) => jsonEncode(vars.toJson());
  Future<QueryResult<GetApplicationsByShiftIdData, GetApplicationsByShiftIdVariables>> execute() {
    return ref().execute();
  }

  QueryRef<GetApplicationsByShiftIdData, GetApplicationsByShiftIdVariables> ref() {
    GetApplicationsByShiftIdVariables vars= GetApplicationsByShiftIdVariables(shiftId: shiftId,);
    return _dataConnect.query("getApplicationsByShiftId", dataDeserializer, varsSerializer, vars);
  }
}

@immutable
class GetApplicationsByShiftIdApplications {
  final String id;
  final String shiftId;
  final String staffId;
  final EnumValue<ApplicationStatus> status;
  final Timestamp? appliedAt;
  final Timestamp? checkInTime;
  final Timestamp? checkOutTime;
  final EnumValue<ApplicationOrigin> origin;
  final Timestamp? createdAt;
  final GetApplicationsByShiftIdApplicationsShift shift;
  final GetApplicationsByShiftIdApplicationsShiftRole shiftRole;
  GetApplicationsByShiftIdApplications.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  shiftId = nativeFromJson<String>(json['shiftId']),
  staffId = nativeFromJson<String>(json['staffId']),
  status = applicationStatusDeserializer(json['status']),
  appliedAt = json['appliedAt'] == null ? null : Timestamp.fromJson(json['appliedAt']),
  checkInTime = json['checkInTime'] == null ? null : Timestamp.fromJson(json['checkInTime']),
  checkOutTime = json['checkOutTime'] == null ? null : Timestamp.fromJson(json['checkOutTime']),
  origin = applicationOriginDeserializer(json['origin']),
  createdAt = json['createdAt'] == null ? null : Timestamp.fromJson(json['createdAt']),
  shift = GetApplicationsByShiftIdApplicationsShift.fromJson(json['shift']),
  shiftRole = GetApplicationsByShiftIdApplicationsShiftRole.fromJson(json['shiftRole']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplications otherTyped = other as GetApplicationsByShiftIdApplications;
    return id == otherTyped.id && 
    shiftId == otherTyped.shiftId && 
    staffId == otherTyped.staffId && 
    status == otherTyped.status && 
    appliedAt == otherTyped.appliedAt && 
    checkInTime == otherTyped.checkInTime && 
    checkOutTime == otherTyped.checkOutTime && 
    origin == otherTyped.origin && 
    createdAt == otherTyped.createdAt && 
    shift == otherTyped.shift && 
    shiftRole == otherTyped.shiftRole;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, shiftId.hashCode, staffId.hashCode, status.hashCode, appliedAt.hashCode, checkInTime.hashCode, checkOutTime.hashCode, origin.hashCode, createdAt.hashCode, shift.hashCode, shiftRole.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['shiftId'] = nativeToJson<String>(shiftId);
    json['staffId'] = nativeToJson<String>(staffId);
    json['status'] = 
    applicationStatusSerializer(status)
    ;
    if (appliedAt != null) {
      json['appliedAt'] = appliedAt!.toJson();
    }
    if (checkInTime != null) {
      json['checkInTime'] = checkInTime!.toJson();
    }
    if (checkOutTime != null) {
      json['checkOutTime'] = checkOutTime!.toJson();
    }
    json['origin'] = 
    applicationOriginSerializer(origin)
    ;
    if (createdAt != null) {
      json['createdAt'] = createdAt!.toJson();
    }
    json['shift'] = shift.toJson();
    json['shiftRole'] = shiftRole.toJson();
    return json;
  }

  GetApplicationsByShiftIdApplications({
    required this.id,
    required this.shiftId,
    required this.staffId,
    required this.status,
    this.appliedAt,
    this.checkInTime,
    this.checkOutTime,
    required this.origin,
    this.createdAt,
    required this.shift,
    required this.shiftRole,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShift {
  final String id;
  final String title;
  final Timestamp? date;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final String? location;
  final EnumValue<ShiftStatus>? status;
  final GetApplicationsByShiftIdApplicationsShiftOrder order;
  GetApplicationsByShiftIdApplicationsShift.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  title = nativeFromJson<String>(json['title']),
  date = json['date'] == null ? null : Timestamp.fromJson(json['date']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  location = json['location'] == null ? null : nativeFromJson<String>(json['location']),
  status = json['status'] == null ? null : shiftStatusDeserializer(json['status']),
  order = GetApplicationsByShiftIdApplicationsShiftOrder.fromJson(json['order']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShift otherTyped = other as GetApplicationsByShiftIdApplicationsShift;
    return id == otherTyped.id && 
    title == otherTyped.title && 
    date == otherTyped.date && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    location == otherTyped.location && 
    status == otherTyped.status && 
    order == otherTyped.order;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, title.hashCode, date.hashCode, startTime.hashCode, endTime.hashCode, location.hashCode, status.hashCode, order.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['title'] = nativeToJson<String>(title);
    if (date != null) {
      json['date'] = date!.toJson();
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (location != null) {
      json['location'] = nativeToJson<String?>(location);
    }
    if (status != null) {
      json['status'] = 
    shiftStatusSerializer(status!)
    ;
    }
    json['order'] = order.toJson();
    return json;
  }

  GetApplicationsByShiftIdApplicationsShift({
    required this.id,
    required this.title,
    this.date,
    this.startTime,
    this.endTime,
    this.location,
    this.status,
    required this.order,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftOrder {
  final String id;
  final String? eventName;
  final GetApplicationsByShiftIdApplicationsShiftOrderTeamHub teamHub;
  final GetApplicationsByShiftIdApplicationsShiftOrderBusiness business;
  final GetApplicationsByShiftIdApplicationsShiftOrderVendor? vendor;
  GetApplicationsByShiftIdApplicationsShiftOrder.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  eventName = json['eventName'] == null ? null : nativeFromJson<String>(json['eventName']),
  teamHub = GetApplicationsByShiftIdApplicationsShiftOrderTeamHub.fromJson(json['teamHub']),
  business = GetApplicationsByShiftIdApplicationsShiftOrderBusiness.fromJson(json['business']),
  vendor = json['vendor'] == null ? null : GetApplicationsByShiftIdApplicationsShiftOrderVendor.fromJson(json['vendor']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftOrder otherTyped = other as GetApplicationsByShiftIdApplicationsShiftOrder;
    return id == otherTyped.id && 
    eventName == otherTyped.eventName && 
    teamHub == otherTyped.teamHub && 
    business == otherTyped.business && 
    vendor == otherTyped.vendor;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, eventName.hashCode, teamHub.hashCode, business.hashCode, vendor.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    if (eventName != null) {
      json['eventName'] = nativeToJson<String?>(eventName);
    }
    json['teamHub'] = teamHub.toJson();
    json['business'] = business.toJson();
    if (vendor != null) {
      json['vendor'] = vendor!.toJson();
    }
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftOrder({
    required this.id,
    this.eventName,
    required this.teamHub,
    required this.business,
    this.vendor,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftOrderTeamHub {
  final String address;
  final String? placeId;
  final String hubName;
  GetApplicationsByShiftIdApplicationsShiftOrderTeamHub.fromJson(dynamic json):
  
  address = nativeFromJson<String>(json['address']),
  placeId = json['placeId'] == null ? null : nativeFromJson<String>(json['placeId']),
  hubName = nativeFromJson<String>(json['hubName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftOrderTeamHub otherTyped = other as GetApplicationsByShiftIdApplicationsShiftOrderTeamHub;
    return address == otherTyped.address && 
    placeId == otherTyped.placeId && 
    hubName == otherTyped.hubName;
    
  }
  @override
  int get hashCode => Object.hashAll([address.hashCode, placeId.hashCode, hubName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['address'] = nativeToJson<String>(address);
    if (placeId != null) {
      json['placeId'] = nativeToJson<String?>(placeId);
    }
    json['hubName'] = nativeToJson<String>(hubName);
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftOrderTeamHub({
    required this.address,
    this.placeId,
    required this.hubName,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftOrderBusiness {
  final String id;
  final String businessName;
  final String? email;
  final String? contactName;
  GetApplicationsByShiftIdApplicationsShiftOrderBusiness.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  businessName = nativeFromJson<String>(json['businessName']),
  email = json['email'] == null ? null : nativeFromJson<String>(json['email']),
  contactName = json['contactName'] == null ? null : nativeFromJson<String>(json['contactName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftOrderBusiness otherTyped = other as GetApplicationsByShiftIdApplicationsShiftOrderBusiness;
    return id == otherTyped.id && 
    businessName == otherTyped.businessName && 
    email == otherTyped.email && 
    contactName == otherTyped.contactName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, businessName.hashCode, email.hashCode, contactName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['businessName'] = nativeToJson<String>(businessName);
    if (email != null) {
      json['email'] = nativeToJson<String?>(email);
    }
    if (contactName != null) {
      json['contactName'] = nativeToJson<String?>(contactName);
    }
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftOrderBusiness({
    required this.id,
    required this.businessName,
    this.email,
    this.contactName,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftOrderVendor {
  final String id;
  final String companyName;
  GetApplicationsByShiftIdApplicationsShiftOrderVendor.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  companyName = nativeFromJson<String>(json['companyName']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftOrderVendor otherTyped = other as GetApplicationsByShiftIdApplicationsShiftOrderVendor;
    return id == otherTyped.id && 
    companyName == otherTyped.companyName;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, companyName.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['companyName'] = nativeToJson<String>(companyName);
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftOrderVendor({
    required this.id,
    required this.companyName,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftRole {
  final String id;
  final String roleId;
  final int count;
  final int? assigned;
  final Timestamp? startTime;
  final Timestamp? endTime;
  final double? hours;
  final double? totalValue;
  final GetApplicationsByShiftIdApplicationsShiftRoleRole role;
  GetApplicationsByShiftIdApplicationsShiftRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  roleId = nativeFromJson<String>(json['roleId']),
  count = nativeFromJson<int>(json['count']),
  assigned = json['assigned'] == null ? null : nativeFromJson<int>(json['assigned']),
  startTime = json['startTime'] == null ? null : Timestamp.fromJson(json['startTime']),
  endTime = json['endTime'] == null ? null : Timestamp.fromJson(json['endTime']),
  hours = json['hours'] == null ? null : nativeFromJson<double>(json['hours']),
  totalValue = json['totalValue'] == null ? null : nativeFromJson<double>(json['totalValue']),
  role = GetApplicationsByShiftIdApplicationsShiftRoleRole.fromJson(json['role']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftRole otherTyped = other as GetApplicationsByShiftIdApplicationsShiftRole;
    return id == otherTyped.id && 
    roleId == otherTyped.roleId && 
    count == otherTyped.count && 
    assigned == otherTyped.assigned && 
    startTime == otherTyped.startTime && 
    endTime == otherTyped.endTime && 
    hours == otherTyped.hours && 
    totalValue == otherTyped.totalValue && 
    role == otherTyped.role;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, roleId.hashCode, count.hashCode, assigned.hashCode, startTime.hashCode, endTime.hashCode, hours.hashCode, totalValue.hashCode, role.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['roleId'] = nativeToJson<String>(roleId);
    json['count'] = nativeToJson<int>(count);
    if (assigned != null) {
      json['assigned'] = nativeToJson<int?>(assigned);
    }
    if (startTime != null) {
      json['startTime'] = startTime!.toJson();
    }
    if (endTime != null) {
      json['endTime'] = endTime!.toJson();
    }
    if (hours != null) {
      json['hours'] = nativeToJson<double?>(hours);
    }
    if (totalValue != null) {
      json['totalValue'] = nativeToJson<double?>(totalValue);
    }
    json['role'] = role.toJson();
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftRole({
    required this.id,
    required this.roleId,
    required this.count,
    this.assigned,
    this.startTime,
    this.endTime,
    this.hours,
    this.totalValue,
    required this.role,
  });
}

@immutable
class GetApplicationsByShiftIdApplicationsShiftRoleRole {
  final String id;
  final String name;
  final double costPerHour;
  GetApplicationsByShiftIdApplicationsShiftRoleRole.fromJson(dynamic json):
  
  id = nativeFromJson<String>(json['id']),
  name = nativeFromJson<String>(json['name']),
  costPerHour = nativeFromJson<double>(json['costPerHour']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdApplicationsShiftRoleRole otherTyped = other as GetApplicationsByShiftIdApplicationsShiftRoleRole;
    return id == otherTyped.id && 
    name == otherTyped.name && 
    costPerHour == otherTyped.costPerHour;
    
  }
  @override
  int get hashCode => Object.hashAll([id.hashCode, name.hashCode, costPerHour.hashCode]);
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['id'] = nativeToJson<String>(id);
    json['name'] = nativeToJson<String>(name);
    json['costPerHour'] = nativeToJson<double>(costPerHour);
    return json;
  }

  GetApplicationsByShiftIdApplicationsShiftRoleRole({
    required this.id,
    required this.name,
    required this.costPerHour,
  });
}

@immutable
class GetApplicationsByShiftIdData {
  final List<GetApplicationsByShiftIdApplications> applications;
  GetApplicationsByShiftIdData.fromJson(dynamic json):
  
  applications = (json['applications'] as List<dynamic>)
        .map((e) => GetApplicationsByShiftIdApplications.fromJson(e))
        .toList();
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdData otherTyped = other as GetApplicationsByShiftIdData;
    return applications == otherTyped.applications;
    
  }
  @override
  int get hashCode => applications.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['applications'] = applications.map((e) => e.toJson()).toList();
    return json;
  }

  GetApplicationsByShiftIdData({
    required this.applications,
  });
}

@immutable
class GetApplicationsByShiftIdVariables {
  final String shiftId;
  @Deprecated('fromJson is deprecated for Variable classes as they are no longer required for deserialization.')
  GetApplicationsByShiftIdVariables.fromJson(Map<String, dynamic> json):
  
  shiftId = nativeFromJson<String>(json['shiftId']);
  @override
  bool operator ==(Object other) {
    if(identical(this, other)) {
      return true;
    }
    if(other.runtimeType != runtimeType) {
      return false;
    }

    final GetApplicationsByShiftIdVariables otherTyped = other as GetApplicationsByShiftIdVariables;
    return shiftId == otherTyped.shiftId;
    
  }
  @override
  int get hashCode => shiftId.hashCode;
  

  Map<String, dynamic> toJson() {
    Map<String, dynamic> json = {};
    json['shiftId'] = nativeToJson<String>(shiftId);
    return json;
  }

  GetApplicationsByShiftIdVariables({
    required this.shiftId,
  });
}

